# flcheck --
#
# This file implements package flcheck, a fusion logic modelchecker 
# using the CUDD BDD package
#
# Copyright (C) 2009, 2010, 2011, 2012, 2013  Antonio Cau

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# System routines 
###########################################
proc STor { a b } {
    return "{stor $a $b}"
}

proc STand { a b } {
    return "{stand $a $b}"
}

proc STnot { a } { 
    return "{stnot $a}"
}

proc FLsat { a } {
    return [list 0 $a ]
}

proc FLvld { a } {
    return [list 1 $a ]
}

proc FLenf { a } {
    return [list 2 $a ]
}

proc FLinf { a } {
    return [list 3 $a ]
}

proc PLsat { a } {
    return [list 4 $a ]
}

proc PLvld { a } {
    return [list 5 $a ]
}

proc PLenf { a } {
    return [list 6 $a ]
}

proc PLinf { a } {
    return [list 7 $a ]
}

proc TRnot { a } {
    return "{trnot $a}"
}

proc TRnext { a } {
    return "{trnext $a}"
}

proc TRor { a b } {
    return "{tror $a $b}"
}

proc TRand { a b } {
    return "{trand $a $b}"
}

proc FEtest { a } {
    return "{fetest $a}"
}

proc FEor { a b } {
    return "{feor $a $b}"
}

proc FEstep { a } {
    return "{festep $a}"
}

proc FEchop { a b } {
    return "{fechop $a $b}"
}

proc FEchopstar { a } {
    return "{fechopstar $a}"
}

proc FLnot { a } {
    return "{flnot $a}"
}

proc FLor { a b } {
    return "{flor $a $b}"
}

proc FLand { a b } {
    return "{fland $a $b}"
}

proc FLchop { a b } {
    return "{flchop $a $b}"
}

proc PLfin { a } {
    return "{plfin $a}"
}

proc PLnot { a } {
    return "{plnot $a}"
}

proc PLor { a b } {
    return "{plor $a $b}"
}

proc PLand { a b } {
    return "{pland $a $b}"
}

proc PLchop { a b } {
    return "{plchop $a $b}"
}


